/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package com.ryuuji.servlet.estudiante.nota;

import java.io.IOException;
import java.util.ArrayList;
import javax.servlet.ServletException;
import javax.servlet.annotation.WebServlet;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;
import logica.Listas;
import logica.Search;
import orm.Curso;
import orm.Estudiante;
import orm.Nota;

/**
 *
 * @author ryuuji
 */
@WebServlet(name = "NotasServlet", urlPatterns = {"/NotasServlet"})
public class NotasServlet extends HttpServlet {

    /**
     * Processes requests for both HTTP <code>GET</code> and <code>POST</code> methods.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    protected void processRequest(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        response.setContentType("text/html;charset=UTF-8");
        HttpSession session = request.getSession(false);
        if (session != null) {
            session.invalidate();
        }

        String cursoSelected = request.getParameter("cursoSelected");
        String asignaturaSelected = request.getParameter("asignaturaSelected");
        String estudianteSelected = request.getParameter("estudianteSelected");

        Curso curso;
        if (cursoSelected != null) {
            curso = Search.buscarCurso(Integer.parseInt(cursoSelected.split("-")[0]), cursoSelected.split("-")[1]);
        } else {
            Curso[] cursos = Search.buscarCursos();
            if (cursos != null) {
                curso = cursos[0];
            } else {
                curso = null;
            }
        }

        Estudiante estudiante;
        if (estudianteSelected != null) {
            estudiante = Search.buscarEstudiante(estudianteSelected);
        } else {
            if (curso != null) {
                Estudiante[] estudiantes = Search.buscarEstudiantes(curso);
                if (estudiantes != null) {
                    estudiante = estudiantes[0];
                } else {
                    estudiante = null;
                }
            } else {
                estudiante = null;
            }
        }

        String[] listaCurso = Listas.listaCursos();
        String[] listaAsignatura;
        String[][] listaEstudiante;

        if (curso != null) {
            listaAsignatura = Listas.listaAsignaturas(curso);
            listaEstudiante = Listas.listaEstudiantes(curso);
        } else {
            listaAsignatura = null;
            listaEstudiante = null;
        }
        Nota[] listaNotasAux;
        if (estudiante != null) {
            listaNotasAux = Search.buscarNotas(estudiante);
        } else {
            listaNotasAux = null;
        }

        ArrayList<Nota> listaNotas = new ArrayList<>();
        if (listaNotasAux != null) {
            for (Nota nota : listaNotasAux) {
                if (nota.getAsignatura_id_fk().getNombre().equals(asignaturaSelected)) {
                    listaNotas.add(nota);
                }
            }
            if (listaNotas.size() > 0) {
                roundNotas(listaNotas);
            }
        }

        request.setAttribute("listaCurso", listaCurso);
        request.setAttribute("listaAsignatura", listaAsignatura);
        request.setAttribute("listaEstudiante", listaEstudiante);
        request.setAttribute("listaNotas", listaNotas);
        request.setAttribute("cursoSelected", cursoSelected);
        request.setAttribute("estudianteSelected", estudianteSelected);
        request.setAttribute("asignaturaSelected", asignaturaSelected);

        request.getRequestDispatcher("notas.jsp").forward(request, response);
    }

    public void roundNotas(ArrayList<Nota> listaNotas) {
        listaNotas.forEach((nota) -> {
            nota.setValor(Math.ceil(nota.getValor() * 10) / 10);
        });
    }

    // <editor-fold defaultstate="collapsed" desc="HttpServlet methods. Click on the + sign on the left to edit the code.">
    /**
     * Handles the HTTP <code>GET</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doGet(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Handles the HTTP <code>POST</code> method.
     *
     * @param request servlet request
     * @param response servlet response
     * @throws ServletException if a servlet-specific error occurs
     * @throws IOException if an I/O error occurs
     */
    @Override
    protected void doPost(HttpServletRequest request, HttpServletResponse response)
            throws ServletException, IOException {
        processRequest(request, response);
    }

    /**
     * Returns a short description of the servlet.
     *
     * @return a String containing servlet description
     */
    @Override
    public String getServletInfo() {
        return "Short description";
    }// </editor-fold>

}
